/* 
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   Copyright (c) Alexey Mahotkin <alexm@hsys.msk.ru> 2001

   Per-module ACL implementation

*/

#ifndef MODULE_ACL_H_
#define MODULE_ACL_H_ 1

#include "repository.h"

enum TAGGING_MODE {
    TAG_TAGGING = 1,
    BRANCH_TAGGING = 2
};

struct MODULE_TAG_ACE {
    char *username;
    char *prefix;
    enum TAGGING_MODE mode;

    struct MODULE_TAG_ACE *next;
    struct MODULE_TAG_ACE *prev;
};

struct MODULE_ACL {
    struct REPOSITORY *repository;
    char *module;
    struct MODULE_TAG_ACE *tag_acl;
    struct MODULE_ACL *next;
};

struct MODULE_ACL *get_module_acl (struct REPOSITORY *repos, char *module);
void free_module_acl (struct MODULE_ACL *macl);

int module_tagging_granted (struct MODULE_ACL *mod_acl,
			    char *username, char *prefix);

int grant_module_tagging (struct MODULE_ACL *mod_acl,
			  char *username, char *prefix);

int revoke_module_tagging (struct MODULE_ACL *mod_acl,
			   char *username, char *prefix);


int module_branching_granted (struct MODULE_ACL *mod_acl,
			      char *username, char *prefix);

int grant_module_branching (struct MODULE_ACL *mod_acl,
			    char *username, char *prefix);

int revoke_module_branching (struct MODULE_ACL *mod_acl,
			     char *username, char *prefix);


#endif /* MODULE_ACL_H_ */
