/* 
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   Copyright (c) Alexey Mahotkin <alexm@hsys.msk.ru> 2001-2002

   Network client using transparent gzip compression.

*/

#ifndef ZLIB_CLIENT_H
#define ZLIB_CLIENT_H 1

#include "network-client.h"

/*
 * Zero if compression isn't supported or requested; non-zero to indicate
 * a compression level to request from gzip.
 */
int get_gzip_level (void);
void set_gzip_level (int level);

/*
 * Level of compression to use when running gzip on a single file.
 */
int get_file_gzip_level (void);
void set_file_gzip_level (int level);


struct network_client *create_zlib_client(cvsroot_t *CVSROOT,
					  ncli_error_cb error_cb);

#endif /* ZLIB_CLIENT_H */
